
-module(dogbot).
-export( [ start/0, squirrel/1, pet/1, pat/1, rest/1, bye/1, foo/2 ] ).
 

start() -> spawn(fun() -> bark() end).


%%=============================================================
%% messages... transition from state to state
%%=============================================================
 
squirrel(Pid) -> Pid ! squirrel.
pet(Pid)      -> Pid ! pet.
bye(Pid)      -> Pid ! bye.
rest(Pid)     -> Pid ! rest.

pat(Pid)      -> Pid ! pat.  % not a valid message
foo(Pid,M)    -> Pid ! M.


%%=============================================================
%% state functions
%%=============================================================
 
bark() -> io:format("Dog says: BARK! BARK!~n"),
          receive
             pet -> wag_tail();
	    rest -> sleeep();
             bye -> done();
               _ -> io:format("Dog is confused~n"),
                   bark()
          after 2000 -> 
             bark()
          end.

done() -> io:format("dog is done... bye!~n"),
	  exit(self(),ok).

sleeep() -> io:format("dog is sleeping... snoring~n"),
            receive
               pet -> bark();
                 _ -> io:format("Dog is out cold... snoring~n"),
                      sleeep()
            after 40000 -> 
               io:format("Dog is waking... stretching...~n"),
               bark()
            end.
 
wag_tail() -> io:format("Dog wags its tail~n"),
              receive
                 pet -> sit();
                   _ -> io:format("Dog is confused~n"),
                        wag_tail()
              after 20000 ->
                 bark()
              end.
 
sit() -> io:format("Dog is sitting. Gooooood boy!~n"),
         receive
           squirrel -> bark();
                  _ -> io:format("Dog is confused~n"),
                       sit()
         end.
