
-module(foo). 
-export([start/0, call/2]). 
-export([one/0, two/0, demo/0]).

% demo the use of the process dictionary as 
% "global data" or "shared state"

one() -> put(pi, 3.14159),
	 put(x, 14),
	 V = 25.9,
	 put(varV, V),
	 put(cheer, "go heels").

two() -> Pi = get(pi),
         X = get(x),
         Msg = get(cheer),
         VV = get(varV),
	 io:fwrite("~s~n",[Msg]),
	 io:fwrite("~p~n",[VV]),
	 io:fwrite("~p~n",[X+Pi]).

demo() -> one(), two().

%%%%% registering process IDs symbolically %%%%%%%%%%%%%%%%%%%%%%%%%%

call(Arg1, Msecs) ->
     io:fwrite("Spawned proc is ~p~n",[self()]),
     timer:sleep(Msecs),
     io:fwrite("Spawned proc says ~p~n",[Arg1]). 

start() -> 
   Pid = spawn(?MODULE, call, ["hello", 2000]),
   io:fwrite("Register ~p under atom myProc~n",[Pid]),
   register(myProc, Pid), 
   io:fwrite("Get pid under atom myProc: ~p~n",[whereis(myProc)]),
   timer:sleep(5000), % wait for spawned proc to end...
                      % see if it is still registered
   io:fwrite("Get pid under atom myProc: ~p~n",[whereis(myProc)]),
   main_done.



