
-module(procs).
-compile([export_all]).

mod() -> io:format("Module name: ~p~n", [?MODULE]).

% these give you the shell process ID
aproc() -> io:format("I'm a process with id ~p~n", [self()]).
bproc() -> io:format("I'm a process with id ~p~n", [self()]).


% spawn processes (threads) and you get separate independent
% process IDs, not the shell

run() -> spawn(fun() -> aproc() end),
         spawn(procs, aproc, []),
         spawn(?MODULE, aproc, []),
	 okay.

% order of spawning has nothing to do with order
% of events coming out of the threads

loop() -> loop().

looper(0) -> doneLoop;
looper(N) -> looper(N-1).

sp(N) -> io:format("I'm a second spawned proc, with id ~p~n", [self()]),
         looper(N),
         io:format("second proc done~n", []).

fp(N) -> io:format("I'm a first spawned proc, with id ~p~n", [self()]),
	 looper(N),
         io:format("first proc done~n", []).


racer(N) -> spawn(?MODULE, fp, [N*N*N]),
            spawn(?MODULE, sp, [N]),
  	    done_spawner.

call(Arg1, Arg2) -> io:format("~p ~p~n", [Arg1, Arg2]). 

start() -> 
   Pid = spawn(?MODULE, call, ["hello", "process"]), 
   io:fwrite("~p",[Pid]).
   

    
