
-module (send_recv).
-compile([export_all]).


serve() -> receive
           MM ->
             io:format("Server handling: ~s~n", [MM]),
             serve()
           end.

math() -> receive
          {add, X, Y} ->
  	    io:format("Math handling: ~p + ~p = ~p~n", [X,Y,X+Y]),
            math();
          {sub, X, Y} ->
	    io:format("Math handling: ~p - ~p = ~p~n", [X,Y,X-Y]),
            math()
          end.

make_request(ServerId, Msg) -> ServerId ! Msg.

longCheck(_,_,0) -> done;
longCheck(P,M,N) -> timer:sleep(3000),
    	            make_request(P, M),
                    longCheck(P,M,N-1).

run(0) -> % are the spawned servers still running out there?
	  Pid = get(pid),  % retrieve the Pid of the last server started
          io:format("~nServer pid we saved is ~p~n", [Pid]),
	  Msg = "server " ++ pid_to_list(Pid) ++ " is still runnning",
	  make_request(Pid, Msg),
	  timer:sleep(2000),
	  make_request(Pid, Msg),
	  longCheck(Pid,Msg,10)  % long loop, but not inf
	  ;

run(X) when  X > 0 ->
    Pid = spawn(?MODULE, serve, []),
    io:format("Server pid is ~p~n", [Pid]),
    put(pid,Pid), % put the Pid into the process dictionary
    make_request(Pid, request1),
    make_request(Pid, request2),

    timer:sleep(2000),
    io:format("~n", []),


    Pid2 = spawn(?MODULE, math, []),
    io:format("Math pid is ~p~n", [Pid2]),
    Pid2 ! {add, 1, 2},
    Pid2 ! {sub, 3, 2},
    Pid2 ! {add, X, math:pow(2,X)},

    timer:sleep(2000),
    io:format("~n", []),

    %okay,
    run(X-1).


